#include "Element.h"

using namespace graphic;

// Full constructor
Element::Element(int r, int c, std::vector < Image * > views, Statsmap stats) :
				IsoObject(r, c), Attributes(stats)
{
	if(views.size() < NUM_VIEWS)
		throw Exception("Element::Element", "an Element misses some images!");

	// store views
	_views = views;

	// set default view
	_img = _views[SOUTH];

	// default orientation
	_direction = SOUTH;
}

Element::Element(int r, int c, std::vector < Image * > views, Statsmap stats, Stringmap strings) :
				IsoObject(r, c), Attributes(stats, strings)
{
	if(views.size() < NUM_VIEWS)
		throw Exception("Element::Element", "an Element misses some images!");

	// store views
	_views = views;

	// set default view
	_img = _views[SOUTH];

	// default orientation
	_direction = SOUTH;
}

Element::Element(int r, int c, std::vector < Image * > views, std::vector <Component *> components) :
				IsoObject(r, c), Attributes(components)
{
	if(views.size() < NUM_VIEWS)
		throw Exception("Element::Element", "an Element misses some images!");

	// store views
	_views = views;

	// set default view
	_img = _views[SOUTH];

	// default orientation
	_direction = SOUTH;
}

// Destroyer
Element::~Element()
{
	_views.clear();
}

